package org.example;

import lombok.Getter;
import org.junit.jupiter.api.Assertions;
import org.junit.jupiter.api.Test;

import java.lang.reflect.Constructor;
import java.lang.reflect.InvocationTargetException;

public class MainTest {
    @Test
    public void test0() throws NoSuchFieldException, IllegalAccessException {
        final var r0 = new MyClass();
        Assertions.assertEquals(19, r0.getField0());

        final var field0 = MyClass.class.getDeclaredField("field0");
        field0.setAccessible(true);
        field0.set(r0, Integer.valueOf(3));

        Assertions.assertEquals(3, r0.getField0());
    }

    @Test
    public void test01() throws NoSuchMethodException, InvocationTargetException, IllegalAccessException {
        final var r0 = new MyClass();
        Assertions.assertEquals(19, r0.getField0());

        final var method0 = MyClass.class.getDeclaredMethod("setField0", Integer.class);
        method0.setAccessible(true);
        method0.invoke(r0, Integer.valueOf(3));

        Assertions.assertEquals(3, r0.getField0());
    }

    @Test
    public void test1() throws NoSuchMethodException, InvocationTargetException, InstantiationException, IllegalAccessException {
        Constructor<MyClass> constructor = MyClass.class.getConstructor();

        MyClass mc = constructor.newInstance();
        Assertions.assertEquals(19, mc.getField0());
    }

    @Test
    public void test2() throws NoSuchMethodException, InvocationTargetException, InstantiationException, IllegalAccessException {
        Constructor<MyClass> constructor = MyClass.class.getDeclaredConstructor(Integer.class);
        constructor.setAccessible(true);
        MyClass mc = constructor.newInstance(Integer.valueOf(13));
        Assertions.assertEquals(13, mc.getField0());
    }

    @Test
    public void test3() throws NoSuchMethodException {
        final var methodTest = Calculator.class.getDeclaredMethod("test");
    }
}

@Getter
class MyClass {
    public MyClass() {
        this(19);
    }

    private MyClass(Integer field0) {
        this.field0 = field0;
    }

    private Integer field0 = 2;

    private void setField0(Integer field0) {
        this.field0 = field0;
    }
}


// create instance using reflection using argument "Ala", 23
// change value of name to "Kot"
// change value of age to 19
class Person {
    private final String name;
    private final Integer age;

    public Person() {
        this(null, null);
    }
    private Person(String name, Integer age) {
        this.name = name;
        this.age = age;
    }
}